#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------

module TT_PickTest
	
	unless file_loaded?('tt_picktest.rb')
	# Menus
	menu = UI.menu('Plugins')
	menu.add_item('Pick Test')	{ Sketchup.active_model.select_tool( PickTest.new ) }
	end
  
  def self.reload
    load __FILE__
  end
	
	class PickTest
  
    def initialize
      @segments = [ [100, 100, 0], [200, 100, 0], [200, 200, 0] ]
    end
    
    def deactivate(view)
      view.invalidate
    end
    
    def resume(view)
      view.invalidate
    end
    
    def onMouseMove(flags, x, y, view)
      view.invalidate
    end

		def onLButtonUp(flags, x, y, view)
      puts "\n=== PickHelper Tests ==="
      
			ph = view.pick_helper(x, y)
			puts "view.pick_helper(x, y): #{ph.best_picked}"
			
			ph.do_pick(x, y)
			puts "ph.do_pick(x, y) - best_picked: #{ph.best_picked}"
      
      puts "all_picked: #{ph.all_picked.inspect}"
      puts "count: #{ph.count.inspect}"
      
      range = 0...ph.count
      
      puts "> Paths:"
      for i in range
        p ph.path_at(i)
      end
      
      puts "> Leaves:"
      for i in range
        p ph.leaf_at(i)
      end
      
      puts "> Element:"
      for i in range
        p ph.element_at(i)
      end
      
      puts "> Transformation:"
      for i in range
        p ph.transformation_at(i)
      end
      
      puts "> Depth:"
      for i in range
        p ph.depth_at(i)
      end
      
      puts "picked_edge: #{ph.picked_edge.inspect}"
      puts "picked_face: #{ph.picked_face.inspect}"
      puts "picked_element: #{ph.picked_element.inspect}"
      
      puts "> Segments:"
      ph1 = view.pick_helper
      ph1.do_pick(x, y)
      puts "  > ph1.pick_segment( pts ): #{ ph1.pick_segment( @segments ) }"
      
      ph2 = view.pick_helper
      puts "  > ph2.pick_segment( pts, x, y ): #{ ph2.pick_segment( @segments, x, y ) }"
      
      ph3 = view.pick_helper
      puts "  > ph3.pick_segment( pts, x, y, 30 ): #{ ph2.pick_segment( @segments, x, y, 30 ) }"
      
      
      ph4 = view.pick_helper
      ph4.do_pick(x, y)
      for i in range
        if ph4.leaf_at(i).is_a?( Sketchup::Face )
          f = ph4.leaf_at(i)
          t = ph4.transformation_at(i)
          pts = f.outer_loop.vertices.map { |v| v.position.transform(t) }
          nf = view.model.active_entities.add_face( pts )
          nf.material = 'red'
        end
      end
		end
    
    def getExtents
      bb = Geom::BoundingBox.new
      bb.add( Sketchup.active_model.bounds )
      bb.add( @segments )
      return bb
    end
    
    def draw(view)
      view.line_stipple = ''
      view.line_width = 5
      view.drawing_color = 'orange'
      view.draw( GL_LINE_STRIP, @segments )
    end
		
	end # class

end # module

#-----------------------------------------------------------------------------
file_loaded('tt_picktest.rb')
#-----------------------------------------------------------------------------